#ifndef PYCASA_NUMERIC_IF_H
#define PYCASA_NUMERIC_IF_H

#define PyArray(o) ((PyArrayObject*)o)

inline PyArray_TYPES pyarraytype(PyObject* o) {
    return (PyArray_TYPES)(PyArray(o)->descr->type_num);
}

inline int pyarrayndim(PyObject* o) {
    return PyArray(o)->nd;
}

inline int pyarraydim(PyObject* o, int n) {
    return PyArray(o)->dimensions[n];
}

// note: strides are in units of *bytes* and
// not in units of elements
inline int pyarraystride(PyObject* o, int n) {
    return PyArray(o)->strides[n];
}

inline int pyarrayelementsize(PyObject* o) {
    return (PyArray(o)->descr->elsize);
}

inline char* pyarraybytes(PyObject* o) {
    return PyArray(o)->data;
}


inline char* pyarraygetptr1(PyObject* o, int n) {
    return pyarraybytes(o)+n*(PyArray(o)->descr->elsize);
}

inline bool pyarrayiscontiguous(PyObject* o) {
    return (bool)PyArray_ISCONTIGUOUS(PyArray(o));
}

inline bool pyarrayisobject(PyObject* o) {
    return pyarraytype(o)==PyArray_OBJECT;
}

// the type specializations


PYCASA_DEFINETYPEMAP(PyArray_CHAR,char);
#define HAVE_PYARRAYSBYTE 1
PYCASA_DEFINETYPEMAP(PyArray_SBYTE,char);
PYCASA_DEFINETYPEMAP(PyArray_INT,int);
PYCASA_DEFINETYPEMAP(PyArray_UINT,unsigned int);
#define HAVE_PYARRAYLONG 1
PYCASA_DEFINETYPEMAP(PyArray_LONG,long);
PYCASA_DEFINETYPEMAP(PyArray_OBJECT,PyObject*);
PYCASA_DEFINETYPEMAP(PyArray_DOUBLE,double);
PYCASA_DEFINETYPEMAP(PyArray_FLOAT,float);
PYCASA_DEFINETYPEMAPEXT(PyArray_CFLOAT,support::mcplx<float>,2*sizeof(float));
PYCASA_DEFINETYPEMAPEXT(PyArray_CDOUBLE,support::mcplx<double>, 2*sizeof(double));

#define HAVE_PYARRAYSTRING 0

#endif
