#ifndef PYCASA_NUMPY_IF_H
#define PYCASA_NUMPY_IF_H

#define PyArray(o) ((PyArrayObject*)(o))

inline PyArray_TYPES pyarraytype(PyObject* o) {
    return PyArray_TYPES(PyArray_TYPE(o));
}

inline int pyarrayndim(PyObject* o) {
    return PyArray_NDIM(o);
}

inline int pyarraydim(PyObject* o, int n) {
    return PyArray_DIM(o, n);
}

inline int pyarraystride(PyObject* o, int n) {
    return PyArray_STRIDE(o, n);
}

inline int pyarrayelementsize(PyObject* o) {
    return PyArray_ITEMSIZE(o);
}

inline char* pyarraybytes(PyObject* o) {
    return PyArray_BYTES(o);
}

inline char* pyarraygetptr1(PyObject* o, int n) {
    return (char*)(PyArray_GETPTR1(o, n));
}

inline bool pyarrayiscontiguous(PyObject* o) {
    return (bool)PyArray_ISCONTIGUOUS(o);
}

inline bool pyarrayisobject(PyObject* o) {
    return PyArray_ISOBJECT(o);
}

// the type specializations

PYCASA_DEFINETYPEMAP(PyArray_CHAR,char);

// numpy does not discriminate between CHAR and SBYTE
#define HAVE_PYARRAYSBYTE 0
//PYCASA_DEFINETYPEMAP(PyArray_SBYTE,signed char);

PYCASA_DEFINETYPEMAP(PyArray_INT,int);
PYCASA_DEFINETYPEMAP(PyArray_UINT,uint);

#define HAVE_PYARRAYLONG 1
PYCASA_DEFINETYPEMAP(PyArray_LONG,long);

PYCASA_DEFINETYPEMAP(PyArray_OBJECT,PyObject*);
PYCASA_DEFINETYPEMAP(PyArray_FLOAT,float);
PYCASA_DEFINETYPEMAP(PyArray_DOUBLE,double);
PYCASA_DEFINETYPEMAP(PyArray_CFLOAT,cfloat);
PYCASA_DEFINETYPEMAP(PyArray_CDOUBLE,cdouble);

#define HAVE_PYARRAYSTRING 1
PYCASA_DEFINETYPEMAP(PyArray_STRING,char);

#endif
